                              MEMBER

  INCLUDE('EQUATES.CLW')
  INCLUDE('AddressFormatterClass.INC'),ONCE

                              MAP
                              END

!==============================================================================
AddressFormatterFieldClass.Construct  PROCEDURE
  CODE
  SELF.Field = ''
  
AddressFormatterFieldClass.Destruct   PROCEDURE
  CODE
  !Ensure that ANY variable memory is freed.
  !(Definitely a problem with ANYs in QUEUEs, 
  !but we're not sure about ANYs in CLASSes.)
  SELF.Field &= NULL
  
AddressFormatterFieldClass.InitField  PROCEDURE(*? pField)
  CODE
  SELF.Field &= pField
  
AddressFormatterFieldClass.SetValue   PROCEDURE(STRING pField)
  CODE
  SELF.Field = pField

AddressFormatterFieldClass.GetValue   PROCEDURE!,STRING
  CODE
  RETURN SELF.Field

!==============================================================================
AddressFormatterClass.Construct   PROCEDURE
  CODE
  SELF.Q &= NEW AddressFormatterFieldQueue

AddressFormatterClass.Destruct    PROCEDURE
  CODE
  LOOP WHILE RECORDS(SELF.Q)
    GET(SELF.Q, 1)
    DISPOSE(SELF.Q.Field)
    DELETE(SELF.Q)
  END

AddressFormatterClass.AddField    PROCEDURE(BYTE pType,*? pField)
  CODE
  CLEAR(SELF.Q)
  SELF.Q.Type   = pType
  SELF.Q.Field &= NEW AddressFormatterFieldClass
  ADD(SELF.Q, SELF.Q.Type)
  SELF.Q.Field.InitField(pField)

AddressFormatterClass.GetField    PROCEDURE(BYTE pType)!,STRING
  CODE
  SELF.Q.Type = pType
  GET(SELF.Q, SELF.Q.Type)
  RETURN SELF.Q.Field.GetValue()
           
AddressFormatterClass.FN      PROCEDURE!,STRING
  CODE
  RETURN CLIP(LEFT(SELF.GetField(AddressFormatterFieldType:FirstName)))

AddressFormatterClass.LN      PROCEDURE!,STRING
  CODE
  RETURN CLIP(LEFT(SELF.GetField(AddressFormatterFieldType:LastName)))
  
AddressFormatterClass.FormatAddressBlock  PROCEDURE!,STRING
  CODE
  RETURN ''

AddressFormatterClass.FormatAddressInline PROCEDURE!,STRING
  CODE
  RETURN ''

AddressFormatterClass.FormatCityStateZip  PROCEDURE!,STRING
  CODE
  RETURN ''

AddressFormatterClass.FormatFirstLastName PROCEDURE!,STRING
  CODE
  RETURN CLIP(LEFT(  SELF.FN() &' '& SELF.LN()  ))

AddressFormatterClass.FormatLastFirstName PROCEDURE!,STRING
  CODE
  RETURN ''

